<template>
  <div id="app">
    <main>
      <div class="search-box">
      <input 
        type="text" 
        class="search-bar" 
        placeholder="Search..."
        v-model="query" 
        @keypress="fetchWeather"
      />

      </div>

      <div class="weather-wrap" v-if="typeof weather.main != 'undefined'">
        <div class="location-box">
        <div class="location">{{ weather.name }}, {{ weather.sys.country }}</div>
        <div class="date">{{ dateBuilder() }}</div>
      </div>
      <div class="weather-box">
        <div class="temp">
          {{ Math.round(weather.main.temp) }}°C </div>
        <div class="weather">{{ weather.weather[0].main }}</div>
    </div>
    <div class="advice"> {{ advice(weather.weather[0].main, Math.round(weather.main.temp )) }} </div>
    </div>
    <div class="gif-wrap" v-if="typeof weather.main == 'undefined'"> <img src="@/assets/kids.gif"> </div>

    </main>

  </div>
</template>

<script>

export default {
  name: 'Weather',
  data () {
    return {
      api_key: 'b540acd920366aed6ce193abadb4f5fb',
      url_base: 'https://api.openweathermap.org/data/2.5/',
      query: '',
      weather: {},
      weer: '',
      temp: ''
    }
  },
  methods:{
    fetchWeather (e) {
      if (e.key == "Enter"){
        fetch(`${this.url_base}weather?q=${this.query}&units=metric&APPID=${this.api_key}`)
        .then( res => {
          return res.json();
        }).then(this.setResults);
      }
    },
    setResults (results) {
      this.weather = results;
    },
    dateBuilder () {
      let d = new Date();
      let months = ["January", "February", "March", "April", "May",
       "June", "July", "August", "September", "October", "November", "December"];
       let days = ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday", 
       "Saturday", "Sunday"];

       let day = days[d.getDay()];
       let date = d.getDate();
       let month = months[d.getMonth()];
       let year = d.getFullYear();

       return `${day} ${date} ${month} ${year}`;
    },
    advice(weer, temp){
      if(weer == 'Clear' && temp > 15){
        return "Water your plants plenty, but do it in the morning and evening, not during the peak heat. Also avoid using cold water"
      }
      else if (weer == 'Clouds' && temp > 15) {
        return "Watering once a day is enough, preferebly morning or eveing."
      }
      else if (weer == 'Clouds' && temp < 15) {
        return "Watering once a day is enough, if the temperature drops even more, every few days will suffice."
      }
      else if(weer == 'Snow' && temp < 4){
        return "Cover all sensitive perennials and early seedlings."
      }
      else if(weer == 'Smoke' && temp > 5){
        return "Wear a mask if needed be outside, otherwise avoid going out today and keep your windows closed."
      }
       else if(weer == 'Rain' && temp < 15){
        return "Watering is not needed today."
      }
      else if(weer == 'Rain' && temp >= 15){
        return "Watering is not needed today, plants that require a lot of water can be watered the next day, if the soil dries up by then."
      }
      else {
        return "Cover all fragile flowering plants and veggetables"
      }
      
    }
  }
}
</script>

<style>
*{
   margin: 0;
  padding: 0;
  box-sizing: border-box;
  }
   body{
    font-family: 'montserrat', sans-serif;
  }
#app {
  background-color: #B6D5B6;
  background-size: cover;
  background-position: bottom;
  transition: 0.4s;
 }
  main{
    min-height: 100vh;
    padding: 25px;
  }

  .weather-wrap .advice{
   color: rgb(90, 121, 91);
    text-align:center;
    font-size: 180%;
    line-height: 1.6;
    padding: 10px 25px;

  background-color: rgba(255, 255, 255, 0.4);
  border-radius: 16px;
  margin: 30px 275px;

  box-shadow: 3px 6px rgba(0, 0, 0, 0.15);


}
  .search-box{
    width: 100%;
    margin-bottom: 30px;
  }
  .search-box .search-bar{
    display: inline-block;
    width: 60%;
    padding:15px;
    color: #313131;
    font-size: 20px;

    appearance: none;
    border: none;
    outline: none;
    background: none;

    box-shadow: 0px 0px 8px rgba(0, 0, 0, 0.25);
    background-color: rgba(255, 255, 255, 0.5);
    border-radius: 0px 16px 0px 16px;
    transition: 0.4s;
  }
  .search-box .search-bar:focus{
    box-shadow: 0px 0px 16px rgba(0, 0, 0, 0.25);
    background-color: rgba(255, 255, 255, 0.75);
    border-radius: 16px 0px 16px 0px;
  }
  .location-box .location{
    color:rgb(90, 121, 91);
    font-size: 32px;
    font-weight: 600;
    text-align: center;
    text-shadow: 1px 3px rgba(0, 0, 0, 0.15);
  }

  .location-box .date{
    color:rgb(90, 121, 91);
    font-size: 20px;
    font-weight: 300;
    font-style: italic;
    text-align: center;
 }
 .weather-box{
  text-align:center;
 }

.weather-box .temp{
  display: inline-block;
  padding: 10px 25px;
  color:rgb(90, 121, 91);
  font-size: 102px;
  font-weight: 900;

  text-shadow: 3px 6px rgba(0, 0, 0, 0.15);
  background-color: rgba(255, 255, 255, 0.4);
  border-radius: 16px;
  margin: 30px 0px;

  box-shadow: 3px 6px rgba(0, 0, 0, 0.15);
}

.weather-box .weather{
   color:rgb(90, 121, 91);
    font-size: 48px;
    font-weight: 700;
    font-style: italic;
    text-shadow: 3px 6px rgba(0, 0, 0, 0.15);
}

</style>
